/*************************************************************************
 *
 * Dalkove ovladani mericich pristroju v SRD pasmu
 * Bakalarska prace, UREL FEKT VUT v Brne
 * (c) 2006, 2007 Ales Povalac, <alpov@alpov.net>, http://www.alpov.net/
 *
 * $Id: MainUnit.cpp 117 2007-04-15 18:49:20Z alpov $
 *
 *************************************************************************/

//---------------------------------------------------------------------------

#include <vcl.h>
#include <assert.h>
#pragma hdrstop

#include "comm.h"

#include "MainUnit.h"
#include "testing.h"
#include "yaesu.h"
#include "elsy.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "CPort"
#pragma link "CPortCtl"
#pragma resource "*.dfm"
TfrmMain *frmMain;
//---------------------------------------------------------------------------

__fastcall TfrmMain::TfrmMain(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::btnOpenCloseComClick(TObject *Sender)
{
    if (ComPort->Connected)
        ComPort->Close();
    else
        ComPort->Open();
}
//---------------------------------------------------------------------------


void __fastcall TfrmMain::FormCreate(TObject *Sender)
{
    PageControl->ActivePageIndex = 0;
    ComPortAfterClose(Sender);
    btnDataCharClick(Sender);
}
//---------------------------------------------------------------------------


void __fastcall TfrmMain::TimerContTimer(TObject *Sender)
{
    btnWPINGClick(this);
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::btnDataCharClick(TObject *Sender)
{
    AnsiString s;
    int i;

    for (i = 0; i < StrToInt(cmbLength->Text); i++) {
        s += (char)('A' + (i % 26));
    }
    txbData->Lines->Text = s;
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::btnDataNumberClick(TObject *Sender)
{
    AnsiString s;
    int i;

    for (i = 0; i < StrToInt(cmbLength->Text); i++) {
        s += (char)('0' + (i % 10));
    }
    txbData->Lines->Text = s;
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::btnDataRandomClick(TObject *Sender)
{
    AnsiString s;
    int i;

    for (i = 0; i < StrToInt(cmbLength->Text); i++) {
        s += (char)(random(126-33)+33);
    }
    txbData->Lines->Text = s;
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::ComPortAfterClose(TObject *Sender)
{
    btnOpenCloseCom->Caption = "Otevt COM";
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::ComPortAfterOpen(TObject *Sender)
{
    btnOpenCloseCom->Caption = "Zavt COM";
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::ComPortRxChar(TObject *Sender, int Count)
{
    PACKET p;
    int length;

    // asynchronni zpracovani pouze pri testovani
    if (PageControl->ActivePage != tabTest)
        return;

    length = receive_packet(&p, 1);

    if (!test_packet(length)) {
        ComPort->ClearBuffer(true, false);
        return;
    }

    if (p.command == CMD_ACK) {
        FRecv++;
        UpdateCounterLabels();
        Sleep(150);

        if (TimerCont->Enabled) {
            TimerCont->Enabled = false;
            TimerContTimer(this);
            TimerCont->Enabled = true;
        }
    }
}
//---------------------------------------------------------------------------

void TfrmMain::UpdateCounterLabels(void)
{
    lblSend->Caption = Format("%d", ARRAYOFCONST((FSend)));
    if (FSend > 0)
        lblRecv->Caption = Format("%d (%d %%)", ARRAYOFCONST((FRecv,  (int)(FRecv*100./FSend))));
    else
        lblRecv->Caption = Format("%d", ARRAYOFCONST((FRecv)));
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::btnWPINGStartStopClick(TObject *Sender)
{
    TimerCont->Interval = StrToIntDef(txbDelayCont->Text, 5000);
    TimerCont->Enabled = !TimerCont->Enabled;
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::cmbLengthCloseUp(TObject *Sender)
{
    btnDataCharClick(Sender);    
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::btnSENDClick(TObject *Sender)
{
    const unsigned char c_baudrate[] = {2, 4, 9, 14, 19, 28, 38, 57, 76, 115, 230};
    const unsigned char c_databits[] = {5, 6, 7, 8};
    const unsigned char c_stopbits[] = {1, 2};
    const unsigned char c_parity[] = {0, 1, 2};

    INTERFACE_PORT port;
    char s[PACKET_DATA_LENGTH];
    int result;

    port.mux = cmbMux->ItemIndex;
    port.baudrate = c_baudrate[cmbBaudrate->ItemIndex];
    port.databits = c_databits[cmbDatabits->ItemIndex];
    port.stopbits = c_stopbits[cmbStopbits->ItemIndex];
    port.parity = c_parity[cmbParity->ItemIndex];
    strcpy(s, txbData->Lines->Text.c_str());

    TestingSendStr(&port, s, StrToIntDef(txbTimeout->Text, 0));
}
//---------------------------------------------------------------------------

void TfrmMain::Log(AnsiString s)
{
    int li = txbLog->Lines->Count;

    txbLog->Lines->Add(s);
    txbLog->Lines->Strings[li] = Format("%4d: ", ARRAYOFCONST((li))) + txbLog->Lines->Strings[li];  

}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::btnLPINGClick(TObject *Sender)
{
    char s[PACKET_DATA_LENGTH];

    strcpy(s, txbData->Lines->Text.c_str());
    TestingSendPing(false, s);
    FSend++;
    UpdateCounterLabels();
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::btnWPINGClick(TObject *Sender)
{
    char s[PACKET_DATA_LENGTH];

    if (StrToIntDef(txbCount->Text, 0) != 0) {
        if (FSend >= StrToInt(txbCount->Text)) {
            TimerCont->Enabled = false;
            return;
        }
    }

    strcpy(s, txbData->Lines->Text.c_str());
    TestingSendPing(true, s);
    FSend++;
    UpdateCounterLabels();
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::btnKmitocetYaesuOutClick(TObject *Sender)
{
    YaesuSetFreq(
        cmbYaesuMux->ItemIndex,
        StrToFloat(txbKmitocetYaesu->Text) * 100000,
        chkSubVfo->Checked
    );
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::btnRezimOutClick(TObject *Sender)
{
    const unsigned char c_mode[] = {0x00, 0x01, 0x02, 0x04, 0x44, 0x48, 0x84, 0x88};
    const unsigned char c_step[] = {0x21, 0x02, 0x42, 0x03, 0x43, 0x53, 0x63, 0x04, 0x14, 0x24, 0x34, 0x44, 0x05, 0x45};

    YaesuSetRecMode(
        cmbYaesuMux->ItemIndex,
        c_mode[cmbModulace->ItemIndex],
        c_step[cmbKrokYaesu->ItemIndex],
        chkSubVfo->Checked
    );
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::btnYaesuInClick(TObject *Sender)
{
    unsigned char status;

    YaesuGetStatus(
        cmbYaesuMux->ItemIndex,
        &status,
        chkSubVfo->Checked
    );

    txbSquelch->Text = (status & 0x80) ? "uzaven" : "oteven";
    txbSMetr->Text = IntToStr(status & 0x3f);  // 0x37 ??!?
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::btnYaesuOnOffClick(TObject *Sender)
{
    YaesuOnOff(
        cmbYaesuMux->ItemIndex,
        (Sender == btnYaesuOn) ? true : false
    );
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::btnKmitocetElsyInClick(TObject *Sender)
{
    int freq;

    if (ElsyGetFreq(cmbElsyMux->ItemIndex, &freq))
        txbKmitocetElsy->Text = IntToStr(freq);
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::btnKmitocetElsyOutClick(TObject *Sender)
{
    ElsySetFreq(
        cmbElsyMux->ItemIndex,
        StrToInt(txbKmitocetElsy->Text)
    );
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::btnUrovenInClick(TObject *Sender)
{
    int level;

    if (ElsyGetLevel(cmbElsyMux->ItemIndex, &level)) {
        level -= 127;
        txbUroven->Text = IntToStr(level);
    }
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::btnUrovenOutClick(TObject *Sender)
{
    ElsySetLevel(
        cmbElsyMux->ItemIndex,
        StrToInt(txbUroven->Text) + 127
    );
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::btnKrokElsyInClick(TObject *Sender)
{
    int step;

    if (ElsyGetStep(cmbElsyMux->ItemIndex, &step)) {
        cmbKrokElsy->ItemIndex = step;
    }
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::btnKrokElsyOutClick(TObject *Sender)
{
    ElsySetStep(
        cmbElsyMux->ItemIndex,
        cmbKrokElsy->ItemIndex
    );
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::btnRozmitaniInClick(TObject *Sender)
{
    int freq;

    if (ElsyGetSweep(cmbElsyMux->ItemIndex, &freq))
        txbRozmitani->Text = IntToStr(freq);
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::btnRozmitaniOutClick(TObject *Sender)
{
    ElsySetSweep(
        cmbElsyMux->ItemIndex,
        StrToInt(txbRozmitani->Text)
    );
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::btnVypnoutModulaciClick(TObject *Sender)
{
    ElsySetModOff(cmbElsyMux->ItemIndex);    
}
//---------------------------------------------------------------------------


void __fastcall TfrmMain::btnZoneStartClick(TObject *Sender)
{
    const int c_freqs[6][1000] = {
        {1e7, 1e8, 1e9, 0},
        {1e7, 2e7, 5e7, 1e8, 2e8, 5e8, 1e9, 2e9, 0},
        {10e6, 11e6, 12e6, 13e6, 15e6, 16e6, 18e6, 20e6, 22e6, 24e6, 27e6, 30e6, 33e6, 36e6, 39e6, 43e6, 47e6, 51e6, 56e6, 62e6, 68e6, 75e6, 82e6, 91e6,
         10e7, 11e7, 12e7, 13e7, 15e7, 16e7, 18e7, 20e7, 22e7, 24e7, 27e7, 30e7, 33e7, 36e7, 39e7, 43e7, 47e7, 51e7, 56e7, 62e7, 68e7, 75e7, 82e7, 91e7,
         10e8, 11e8, 12e8, 13e8, 15e8, 16e8, 18e8, 20e8, 0}
    };
    int cfs = cmbZoneStep->ItemIndex;
    int i, j;
    unsigned char status;
    AnsiString s = "";

    Screen->Cursor = crHourGlass;
    lblMeasuring->Visible = true;
    txbZoneLog->Clear();

    try {
        // nastaveni generatoru
        if (!ElsySetLevel(cmbZoneElsyMux->ItemIndex, StrToIntDef(txbZoneLevel->Text, 0) + 127))
            Abort();
        if (!ElsySetModOff(cmbZoneElsyMux->ItemIndex))
            Abort();

        // nastaveni prijimace
        if (!YaesuOnOff(cmbZoneYeasuMux->ItemIndex, true))
            Abort();
        if (!YaesuSetRecMode(cmbZoneYeasuMux->ItemIndex, 0x04, 0x02, false))
            Abort(); // AM, 100Hz

        for (i = 0; (j = c_freqs[cfs][i]) != 0; i++) {
            // nastaveni frekvenci
            if (!ElsySetFreq(cmbZoneElsyMux->ItemIndex, j))
                continue;
            if (!YaesuSetFreq(cmbZoneYeasuMux->ItemIndex, j / 10, false))
                continue;

            Sleep(1000);

            // cteni urovne
            if (!YaesuGetStatus(cmbZoneYeasuMux->ItemIndex, &status, false))
                continue;
            status &= 0x3f;

            txbZoneLog->Lines->Add(Format("Frekvence: %10d Hz -- Level: %2d", ARRAYOFCONST((j, status))));
            s += IntToStr(j) + "\t" + IntToStr(status) + "\n";
        }

        // konec
        if (!ElsySetLevel(cmbZoneElsyMux->ItemIndex, 0))
            Abort();
        if (!YaesuOnOff(cmbZoneYeasuMux->ItemIndex, false))
            Abort();
        Clipboard()->SetTextBuf(s.c_str());
        Screen->Cursor = crDefault;
        lblMeasuring->Visible = false;

    } catch (...) {
        Screen->Cursor = crDefault;
        lblMeasuring->Visible = false;
        txbZoneLog->Lines->Add("Chyba komunikace");
    }

}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::SpeedButton1Click(TObject *Sender)
{
    FSend = 0;
    FRecv = 0;
    UpdateCounterLabels();    
}
//---------------------------------------------------------------------------

