/*************************************************************************
 *
 * Dalkove ovladani mericich pristroju v SRD pasmu
 * Bakalarska prace, UREL FEKT VUT v Brne
 * (c) 2006, 2007 Ales Povalac, <alpov@alpov.net>, http://www.alpov.net/
 *
 * $Id: elsy.cpp 105 2007-04-03 14:03:40Z alpov $
 *
 *************************************************************************/

//---------------------------------------------------------------------------


#pragma hdrstop

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "comm.h"
#include "elsy.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)

bool ElsyInternalSend(int mux, char *command)
{
    PACKET p;
    int result;

    p.command = CMD_SEND;
    p.port.mux = mux;
    p.port.baudrate = 9;
    p.port.databits = 8;
    p.port.stopbits = 1;
    p.port.parity = 0;
    p.timeout = 20; // 200ms ???
    strcpy((char*)(&p.data), command);

    transmit_packet(&p, strlen(command));
    result = receive_packet(&p, TIMEOUT + 20);

    if (test_packet(result)) {
        p.data[result] = 0;
        strcpy(command, (char*)(&p.data));
        return true;
    } else return false;
}


bool ElsySetFreq(int mux, int freq)
{
    char s[PACKET_DATA_LENGTH];

    sprintf(s, "SFR%.10d\r", freq);
    if (ElsyInternalSend(mux, s)) {
        return (strcmp(s, "SOK\r") == 0);
    } else return false;
}


bool ElsyGetFreq(int mux, int *freq)
{
    char s[PACKET_DATA_LENGTH];
    char r[20];

    sprintf(s, "RFR\r");
    if (ElsyInternalSend(mux, s)) {
        strcpy(r, &s[3]);
        *freq = atol(r);
        s[3] = '\0';
        return (strcmp(s, "SFR") == 0);
    } else return false;
}


bool ElsySetStep(int mux, int step)
{
    char s[PACKET_DATA_LENGTH];

    sprintf(s, "SST%.2d\r", step);
    if (ElsyInternalSend(mux, s)) {
        return (strcmp(s, "SOK\r") == 0);
    } else return false;
}


bool ElsyGetStep(int mux, int *step)
{
    char s[PACKET_DATA_LENGTH];
    char r[20];

    sprintf(s, "RST\r");
    if (ElsyInternalSend(mux, s)) {
        strcpy(r, &s[3]);
        *step = atol(r);
        s[3] = '\0';
        return (strcmp(s, "SST") == 0);
    } else return false;
}


bool ElsySetLevel(int mux, int level)
{
    char s[PACKET_DATA_LENGTH];

    sprintf(s, "SLV%.3d%d\r", level, 3 /*dBm*/);
    if (ElsyInternalSend(mux, s)) {
        return (strcmp(s, "SOK\r") == 0);
    } else return false;
}


bool ElsyGetLevel(int mux, int *level)
{
    char s[PACKET_DATA_LENGTH];
    char r[20];

    sprintf(s, "RLV\r");
    if (ElsyInternalSend(mux, s)) {
        strcpy(r, &s[3]);
        r[3] = '\0';
        *level = atol(r);
        s[3] = '\0';
        return (strcmp(s, "SLV") == 0);
    } else return false;
}


bool ElsySetSweep(int mux, int freq)
{
    char s[PACKET_DATA_LENGTH];

    sprintf(s, "SSW%.10d\r", freq);
    if (ElsyInternalSend(mux, s)) {
        return (strcmp(s, "SOK\r") == 0);
    } else return false;
}


bool ElsyGetSweep(int mux, int *freq)
{
    char s[PACKET_DATA_LENGTH];
    char r[20];

    sprintf(s, "RSW\r");
    if (ElsyInternalSend(mux, s)) {
        strcpy(r, &s[3]);
        *freq = atol(r);
        s[3] = '\0';
        return (strcmp(s, "SSW") == 0);
    } else return false;
}


bool ElsySetModOff(int mux)
{
    char s[PACKET_DATA_LENGTH];

    sprintf(s, "SMO\r");
    if (ElsyInternalSend(mux, s)) {
        return (strcmp(s, "SOK\r") == 0);
    } else return false;
}



