/*************************************************************************
 *
 * Dalkove ovladani mericich pristroju v SRD pasmu
 * Bakalarska prace, UREL FEKT VUT v Brne
 * (c) 2006, 2007 Ales Povalac, <alpov@alpov.net>, http://www.alpov.net/
 *
 * $Id: proto.h 96 2007-03-19 08:15:12Z alpov $
 *
 *************************************************************************/

#ifndef protoH
#define protoH

#define PACKET_HEADER_LENGTH    (sizeof(PACKET) - PACKET_DATA_LENGTH)
#define PACKET_DATA_LENGTH      64

typedef struct {
    unsigned char mux:3; // vcetne slave
    unsigned char dummy:5;

    unsigned char baudrate;

    unsigned char databits:4;
    unsigned char stopbits:2;
    unsigned char parity:2;
} INTERFACE_PORT;

typedef union {
    struct {
        unsigned char command; // ktery port / ping
        INTERFACE_PORT port;
        unsigned char timeout; // response timeout
        unsigned char data[PACKET_DATA_LENGTH];
    };
    unsigned char raw_data[0];
} PACKET;

#define CMD_SEND                0x10

#define CMD_LPING               0x90
#define CMD_WPING               0x91

#define CMD_ACK                 0xa0

#define ERR_BADCRC              -1
#define ERR_COMMERR             -3
#define ERR_TIMEOUT             -4

#define TIMEOUT                 150
#define test_packet(x)          ((x >= 0) ? true : false)

#endif
