/*************************************************************************
 *
 * Dalkove ovladani mericich pristroju v SRD pasmu
 * Bakalarska prace, UREL FEKT VUT v Brne
 * (c) 2006, 2007 Ales Povalac, <alpov@alpov.net>, http://www.alpov.net/
 *
 * $Id: yaesu.cpp 99 2007-03-20 15:08:00Z alpov $
 *
 *************************************************************************/

//---------------------------------------------------------------------------


#pragma hdrstop

#include <string.h>
#include "comm.h"
#include "yaesu.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)


bool YaesuOnOff(int mux, bool on_off)
{
    PACKET p;
    int result;

    p.command = CMD_SEND;
    p.port.mux = mux;
    p.port.baudrate = 4;
    p.port.databits = 8;
    p.port.stopbits = 2;
    p.port.parity = 0;
    p.timeout = 0;
    p.data[0] = 0x00;
    p.data[1] = 0x00;
    p.data[2] = 0x00;
    p.data[3] = 0x00;
    p.data[4] = on_off ? 0x00 : 0x80;

    transmit_packet(&p, 5);
    result = receive_packet(&p, TIMEOUT);

    return (test_packet(result));
}


bool YaesuSetFreq(int mux, int freq, bool sub_vfo)
{
    PACKET p;
    int result;

    p.command = CMD_SEND;
    p.port.mux = mux;
    p.port.baudrate = 4;
    p.port.databits = 8;
    p.port.stopbits = 2;
    p.port.parity = 0;
    p.timeout = 0;
    p.data[0] = (freq & 0xff000000) >> 24;
    p.data[1] = (freq & 0x00ff0000) >> 16;
    p.data[2] = (freq & 0x0000ff00) >> 8;
    p.data[3] = (freq & 0x000000ff) >> 0;
    p.data[4] = sub_vfo ? 0x31 : 0x01;

    transmit_packet(&p, 5);
    result = receive_packet(&p, TIMEOUT);

    return (test_packet(result));
}


bool YaesuSetRecMode(int mux, int mode, int step, bool sub_vfo)
{
    PACKET p;
    int result;

    p.command = CMD_SEND;
    p.port.mux = mux;
    p.port.baudrate = 4;
    p.port.databits = 8;
    p.port.stopbits = 2;
    p.port.parity = 0;
    p.timeout = 0;
    p.data[0] = (mode & 0x000000ff);
    p.data[1] = (step & 0x000000ff);
    p.data[2] = 0x00;
    p.data[3] = 0x00;
    p.data[4] = sub_vfo ? 0x37 : 0x07;

    transmit_packet(&p, 5);
    result = receive_packet(&p, TIMEOUT);

    return (test_packet(result));
}


bool YaesuGetStatus(int mux, unsigned char *status, bool sub_vfo)
{
    PACKET p;
    int result;

    p.command = CMD_SEND;
    p.port.mux = mux;
    p.port.baudrate = 4;
    p.port.databits = 8;
    p.port.stopbits = 2;
    p.port.parity = 0;
    p.timeout = 25; // 250ms
    p.data[0] = 0x00;
    p.data[1] = 0x00;
    p.data[2] = 0x00;
    p.data[3] = 0x00;
    p.data[4] = sub_vfo ? 0xe7 : 0xd7;

    transmit_packet(&p, 5);
    result = receive_packet(&p, TIMEOUT + 25);

    *status = p.data[0];

    return (test_packet(result) && (result == 1));
}
